#==============================================
# 10. ̹ Open API Ȱ
#==============================================

#====================================================
# I. Naver Open API  α ˻ =>  Ȯ
#====================================================

install.packages("RCurl")
install.packages("XML")
library(RCurl)
library(XML)

#-----------------------------------
# ̹ API url
# 1) blog url : https://openapi.naver.com/v1/search/blog.xml
# 2) news url : https://openapi.naver.com/v1/search/news.xml
#-----------------------------------
searchUrl <- "https://openapi.naver.com/v1/search/blog.xml"

#-----------------------------------
# ̹ API Ű 
# https://developers.naver.com/apps/#/list  Ȯ
#-----------------------------------
Client_ID <- "yv...gv"      
Client_Secret <- "qb...PJ"


#-----------------------------------
# <1> α ˻ 
#-----------------------------------

no_display <- 20;                                                     # ˻   : 20
query <- URLencode(iconv("õ丮","euc-kr","UTF-8"))              # iconv() : Ű 'õ丮' ѱڵ ȯ
url <- paste(searchUrl, "?query=", query, "&display=", no_display, sep="")

doc <- getURL(url, 
    httpheader = c('Content-Type' = "application/xml",
        'X-Naver-Client-Id' = Client_ID,
        'X-Naver-Client-Secret' = Client_Secret))

# p.272
#-----------------------------------
# <2> α  Ʈ  =>    ϳ   ҷ 
#-----------------------------------
doc2 <- htmlParse(doc, encoding="UTF-8")
text <- xpathSApply(doc2, "//item/description", xmlValue) 
text

#====================================================
# II. Ȯ  ðȭ : 1) Ʈ ۼ, 2)  Ŭ
#     (8  Ŭ )
#====================================================

# p.274
#-----------------------------------
# <1>  ó : 1)   ܾ 
#-----------------------------------

# install.packages("KoNLP")
# install.packages("RColorBrewer")
# install.packages("wordcloud")
library(KoNLP)
library(RColorBrewer)   
library(wordcloud)

useSejongDic() 

noun <- sapply(text, extractNoun, USE.NAMES=F)     #   ܾ 
noun   

# p.275
noun2 <- unlist(noun)         #  ܾ ͷ 
noun2

# p.276
#-----------------------------------
# <2> 纰 ǥ ۼ : 
#      (2-1)~(2-3) ݺ Ѵ.
#-----------------------------------
wordcount <- table(noun2)    # ܾ 󵵼 ( ǥ) ľ
wordcount   

#-----------------------------------
# 2-1) ʿ ܾ 
#-----------------------------------
noun2 <- Filter(function(x){nchar(x) >= 2}, noun2)
noun2  

# p.277
noun2 <- gsub('\\d+', '', noun2)
noun2 <- gsub('<b>', '', noun2)
noun2 <- gsub('</b>', '', noun2)
noun2 <- gsub('&amp', '', noun2)
noun2 <- gsub('&lt', '', noun2)
noun2 <- gsub('&gt', '', noun2)
noun2 <- gsub('&quot;', '', noun2)
noun2 <- gsub('"', '', noun2)
noun2 <- gsub('\'', '', noun2)
noun2 <- gsub(' ', '', noun2)
noun2 <- gsub('-', '', noun2)
# noun2 <- gsub('++', '', noun2)   # ʿ '++' 

noun2

#-----------------------------------
# 2-2> ʿ ܾ ߰
#-----------------------------------
mergeUserDic(data.frame(c(""), c("ncn")))  # ߰ ܾ 


#-----------------------------------
# 2-3> 纰 ǥ ۼ ٽ Ȯ
#-----------------------------------
wordcount <- table(noun2)
head(sort(wordcount, decreasing=T), 30)


#---------------------------------------------
# <3> wordcount Ʈ ۼ
#---------------------------------------------
temp <- sort(wordcount, decreasing=T)[1:30] # (󵵰   Ϳ    ) ܾ ,  30 
temp                                         # Ȯ

temp <- temp[-1]                                # ܾ 
barplot(temp, las = 2, names.arg = names(temp), # Ʈ     
         col =rainbow(30), main ="Most frequent words", # ,  Է       
         ylab = "Word frequencies", ylim = c(0,10)) #  Է



# p.278
#---------------------------------------------
# <4> wordcloud ۼ
#---------------------------------------------

palete <- brewer.pal(9,"Set1") 

wordcloud(names(wordcount), 
          freq=wordcount, 
          scale=c(5,0.25), 
          rot.per=0.25, 
          min.freq=1, 
          random.order=F,  
          random.color=T, 
          colors=palete)